mklive.sh.in 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424
  1. #!/bin/bash
  2. #
  3. # vim: set ts=4 sw=4 et:
  4. #
  5. #-
  6. # Copyright (c) 2009-2013 Juan Romero Pardines.
  7. # All rights reserved.
  8. #
  9. # Redistribution and use in source and binary forms, with or without
  10. # modification, are permitted provided that the following conditions
  11. # are met:
  12. # 1. Redistributions of source code must retain the above copyright
  13. # notice, this list of conditions and the following disclaimer.
  14. # 2. Redistributions in binary form must reproduce the above copyright
  15. # notice, this list of conditions and the following disclaimer in the
  16. # documentation and/or other materials provided with the distribution.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  20. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  21. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  22. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  23. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  24. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  25. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  26. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  27. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  28. #-
  29. set -E
  30. trap "echo; error_out $LINENO $?" INT TERM HUP ERR
  31. readonly PROGNAME=$(basename $0)
  32. info_msg() {
  33. printf "\033[1m$@\n\033[m"
  34. }
  35. error_out() {
  36. info_msg "There was an error in line $1 ... cleaning up $BUILDDIR, exiting."
  37. [ -d "$BUILDDIR" ] && rm -rf "$BUILDDIR"
  38. exit 1
  39. }
  40. write_etc_motd() {
  41. cat >> "$ROOTFS/etc/motd" <<_EOF
  42. ###############################################################################
  43. Autogenerated by void-mklive "@@MKLIVE_VERSION@@"
  44. ###############################################################################
  45. Welcome to the Void Linux Live system, you have been autologged in.
  46. This user has full sudo(8) permissions without any password, be careful
  47. executing commands through sudo(8).
  48. To start the installation please type:
  49. $ sudo void-installer
  50. and follow the on-screen instructions. Thanks for using Void Linux.
  51. http://www.voidlinux.eu
  52. ###############################################################################
  53. _EOF
  54. }
  55. write_conf_file() {
  56. cat > "$1" <<_EOF
  57. # *-*- sh -*-*
  58. # Default configuration file for vmklive-@VERSION@.
  59. #
  60. # List of packages to be installed into the live image.
  61. #
  62. # The 'base-system' package is always added to the generated image.
  63. #
  64. # To build an official live image add the following packages:
  65. # - dialog
  66. # - f2fs-tools
  67. # - grub-x86_64-efi
  68. PACKAGE_LIST="dialog f2fs-tools grub-x86_64-efi"
  69. # Default Void Linux splash image for grub/syslinux.
  70. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  71. # Default keymap to use.
  72. KEYMAP=us
  73. # Default locale to use.
  74. LOCALE=en_US.UTF-8
  75. # Path to XBPS utilities.
  76. #XBPS_INSTALL_CMD=xbps-install
  77. #XBPS_QUERY_CMD=xbps-query
  78. #XBPS_RECONFIGURE_CMD=xbps-reconfigure
  79. #XBPS_REMOVE_CMD=xbps-remove
  80. #XBPS_RINDEX_CMD=xbps-rindex
  81. #XBPS_UHELPER_CMD=xbps-uhelper
  82. # XBPS cache directory to install packages from.
  83. #REPOSITORY_CACHE=/blah/foo
  84. _EOF
  85. chmod 644 "$1"
  86. }
  87. usage() {
  88. cat <<_EOF
  89. Usage: $(basename $0) [options]
  90. Options:
  91. -C file Path to configuration file (defaults to ~/.mklive.conf)
  92. -c (gzip|bzip2|xz) Compression type for the initramfs/squashfs image.
  93. -r rootdir Use this directory to generate the image (if unset, defaults to cwd).
  94. -o outfile Output file name for the ISO image.
  95. -s splash Splash image file for isolinux.
  96. -V Show version.
  97. _EOF
  98. exit 1
  99. }
  100. install_packages() {
  101. for f in ${PACKAGE_LIST}; do
  102. info_msg " $f"
  103. done
  104. # Check that all pkgs are reachable.
  105. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -n ${PACKAGE_LIST} >>$LOGFILE 2>&1
  106. if [ $? -ne 0 ]; then
  107. info_msg "Missing required binary packages, exiting..."
  108. error_out
  109. fi
  110. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} ${PACKAGE_LIST} >>$LOGFILE 2>&1
  111. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -u >>$LOGFILE 2>&1
  112. ${XBPS_REMOVE_CMD} ${XBPS_ARGS} -o >>$LOGFILE 2>&1
  113. ${XBPS_QUERY_CMD} -r "$ROOTFS" -l | sort > "${OUTPUT_FILE%.iso}"-package-list.txt
  114. # Enable choosen UTF-8 locale and generate it into the target rootfs.
  115. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $ROOTFS/etc/default/libc-locales
  116. systemd-nspawn -D $ROOTFS xbps-reconfigure -fa >>$LOGFILE 2>&1
  117. # Enable some services if found.
  118. if [ -f $ROOTFS/usr/lib/systemd/system/NetworkManager.service ]; then
  119. systemd-nspawn -D $ROOTFS systemctl enable NetworkManager.service >>$LOGFILE 2>&1
  120. fi
  121. install -Dm755 /usr/sbin/void-installer $ROOTFS/usr/sbin/void-installer
  122. }
  123. generate_initramfs() {
  124. # Install required pkgs in a temporary rootdir to create
  125. # the initramfs and to copy required files.
  126. $XBPS_INSTALL_CMD -r $ROOTFS/kernel_temp -Sy \
  127. base-system void-mklive -c $REPOSITORY_CACHE >>$LOGFILE 2>&1
  128. systemd-nspawn -D $ROOTFS/kernel_temp /usr/bin/dracut --${COMPRESSTYPE} \
  129. --force-add "vmklive" "/boot/initrd.lz" $KERNELVERSION >>$LOGFILE 2>&1
  130. mv $ROOTFS/kernel_temp/boot/initrd.lz $BOOT_DIR
  131. cp $ROOTFS/kernel_temp/boot/vmlinuz-$KERNELVERSION $BOOT_DIR/vmlinuz
  132. rm -rf $ROOTFS/kernel_temp
  133. }
  134. generate_isolinux_boot() {
  135. cp -f $SYSLINUX_DATADIR/isolinux.bin "$ISOLINUX_DIR"
  136. cp -f $SYSLINUX_DATADIR/ldlinux.c32 "$ISOLINUX_DIR"
  137. cp -f $SYSLINUX_DATADIR/libcom32.c32 "$ISOLINUX_DIR"
  138. cp -f $SYSLINUX_DATADIR/vesamenu.c32 "$ISOLINUX_DIR"
  139. cp -f $SYSLINUX_DATADIR/libutil.c32 "$ISOLINUX_DIR"
  140. cp -f $SYSLINUX_DATADIR/chain.c32 "$ISOLINUX_DIR"
  141. cp -f $MKLIVE_DATADIR/isolinux.cfg.in \
  142. "$ISOLINUX_DIR"/isolinux.cfg
  143. if [ -f "$SPLASH_IMAGE" ]; then
  144. cp -f $SPLASH_IMAGE "$ISOLINUX_DIR"
  145. fi
  146. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  147. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  148. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  149. -e "s|@@ARCH@@|$(uname -m)|" \
  150. -e "s|@@LOCALE@@|${LOCALE}|" $ISOLINUX_DIR/isolinux.cfg
  151. }
  152. generate_grub_efi_boot() {
  153. cp -f $MKLIVE_DATADIR/grub.cfg $GRUB_DIR
  154. cp -f $MKLIVE_DATADIR/grub_void.cfg.in $GRUB_DIR/grub_void.cfg
  155. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  156. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  157. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  158. -e "s|@@ARCH@@|$(uname -m)|" \
  159. -e "s|@@LOCALE@@|${LOCALE}|" $GRUB_DIR/grub_void.cfg
  160. mkdir -p $GRUB_DIR/fonts
  161. cp -f $GRUB_DATADIR/unicode.pf2 $GRUB_DIR/fonts
  162. # Create EFI vfat image.
  163. dd if=/dev/zero of=$GRUB_DIR/efiboot.img bs=1024 count=4096 >>$LOGFILE 2>&1
  164. mkfs.vfat -F12 -S 512 -n "grub_uefi" "$GRUB_DIR/efiboot.img" >>$LOGFILE 2>&1
  165. GRUB_EFI_TMPDIR="$(mktemp --tmpdir=$HOME -d)"
  166. LOOP_DEVICE="$(losetup --show --find ${GRUB_DIR}/efiboot.img)"
  167. mount -o rw,flush -t vfat "${LOOP_DEVICE}" "${GRUB_EFI_TMPDIR}" >>$LOGFILE 2>&1
  168. mkdir -p "${GRUB_EFI_TMPDIR}/EFI/boot/"
  169. cd "$BUILDDIR"
  170. grub-mkstandalone --directory="/usr/lib/grub/x86_64-efi" \
  171. --format="x86_64-efi" \
  172. --compression="xz" --output="${GRUB_EFI_TMPDIR}/EFI/boot/bootx64.efi" \
  173. "boot/grub/grub.cfg" >>$LOGFILE 2>&1
  174. umount "$GRUB_EFI_TMPDIR"
  175. losetup --detach "${LOOP_DEVICE}"
  176. rm -rf $GRUB_EFI_TMPDIR
  177. }
  178. generate_squashfs() {
  179. # Find out required size for the rootfs and create an ext3fs image off it.
  180. ROOTFS_SIZE=$(du -sk "$ROOTFS"|awk '{print $1}')
  181. mkdir -p "$BUILDDIR/tmp/LiveOS"
  182. dd if=/dev/zero of="$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  183. bs="$((${ROOTFS_SIZE}+($ROOTFS_SIZE/6)))K" count=1 >>$LOGFILE 2>&1
  184. mkdir -p "$BUILDDIR/tmp-rootfs"
  185. mkfs.ext3 -F -m1 "$BUILDDIR/tmp/LiveOS/ext3fs.img" >>$LOGFILE 2>&1
  186. mount -o loop "$BUILDDIR/tmp/LiveOS/ext3fs.img" "$BUILDDIR/tmp-rootfs"
  187. cd $BUILDDIR
  188. cp -a rootfs/* tmp-rootfs/
  189. umount -f "$BUILDDIR/tmp-rootfs"
  190. mkdir -p "$BUILDDIR/LiveOS"
  191. mksquashfs "$BUILDDIR/tmp" "$BUILDDIR/LiveOS/squashfs.img" \
  192. -comp ${COMPRESSTYPE} >>$LOGFILE 2>&1
  193. chmod 444 "$BUILDDIR/LiveOS/squashfs.img"
  194. # Remove rootfs and temporary dirs, we don't need them anymore.
  195. rm -rf "$ROOTFS" "$BUILDDIR/tmp-rootfs" "$BUILDDIR/tmp"
  196. }
  197. generate_iso_image() {
  198. xorriso -as mkisofs \
  199. -iso-level 3 -rock -joliet \
  200. -max-iso9660-filenames -omit-period \
  201. -omit-version-number -relaxed-filenames -allow-lowercase \
  202. -volid "VOID_LIVE" \
  203. -eltorito-boot boot/isolinux/isolinux.bin \
  204. -eltorito-catalog boot/isolinux/boot.cat \
  205. -no-emul-boot -boot-load-size 4 -boot-info-table \
  206. -eltorito-alt-boot -e boot/grub/efiboot.img -isohybrid-gpt-basdat -no-emul-boot \
  207. -isohybrid-mbr $SYSLINUX_DATADIR/isohdpfx.bin \
  208. -output "$OUTPUT_FILE" "$BUILDDIR" >>$LOGFILE 2>&1
  209. }
  210. #
  211. # main()
  212. #
  213. while getopts "C:c:o:r:s:hV" opt; do
  214. case $opt in
  215. C) CONFIG_FILE="$OPTARG";;
  216. c) COMPRESSTYPE="$OPTARG";;
  217. o) OUTPUT_FILE="$OPTARG";;
  218. r) ROOTDIR="$OPTARG";;
  219. s) SPLASH_IMAGE="$OPTARG";;
  220. h) usage;;
  221. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  222. esac
  223. done
  224. shift $(($OPTIND - 1))
  225. # Set defaults
  226. if [ -z "$CONFIG_FILE" ]; then
  227. CONFIG_FILE="$HOME/.mklive.conf"
  228. fi
  229. LOGFILE="$(mktemp -t vmklive-XXXXXXXXXX.log)"
  230. if [ -z "$SYSLINUX_DATADIR" ]; then
  231. SYSLINUX_DATADIR=/usr/share/syslinux
  232. fi
  233. if [ -z "$GRUB_DATADIR" ]; then
  234. GRUB_DATADIR=/usr/share/grub
  235. fi
  236. if [ -z "$MKLIVE_DATADIR" ]; then
  237. MKLIVE_DATADIR=/usr/share/void-mklive
  238. fi
  239. if [ -z "$SPLASH_IMAGE" ]; then
  240. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  241. fi
  242. if [ -z "$XBPS_INSTALL_CMD" ]; then
  243. XBPS_INSTALL_CMD=xbps-install
  244. fi
  245. if [ -z "$XBPS_REMOVE_CMD" ]; then
  246. XBPS_REMOVE_CMD=xbps-remove
  247. fi
  248. if [ -z "$XBPS_QUERY_CMD" ]; then
  249. XBPS_QUERY_CMD=xbps-query
  250. fi
  251. if [ -z "$XBPS_RINDEX_CMD" ]; then
  252. XBPS_RINDEX_CMD=xbps-rindex
  253. fi
  254. if [ -z "$XBPS_UHELPER_CMD" ]; then
  255. XBPS_UHELPER_CMD=xbps-uhelper
  256. fi
  257. if [ -z "$XBPS_RECONFIGURE_CMD" ]; then
  258. XBPS_RECONFIGURE_CMD=xbps-reconfigure
  259. fi
  260. if [ -z "$COMPRESSTYPE" ]; then
  261. COMPRESSTYPE=xz
  262. fi
  263. if [ -z "$REPOSITORYCACHE" ]; then
  264. REPOSITORY_CACHE="/var/cache/xbps"
  265. fi
  266. # Create or read configuration file.
  267. if [ ! -r $CONFIG_FILE ]; then
  268. info_msg "Creating config file at $CONFIG_FILE."
  269. write_conf_file $CONFIG_FILE
  270. fi
  271. . $CONFIG_FILE
  272. if [ -z "$PACKAGE_LIST" ]; then
  273. PACKAGE_LIST="base-system"
  274. else
  275. PACKAGE_LIST="base-system $PACKAGE_LIST"
  276. fi
  277. if [ ! -f $SYSLINUX_DATADIR/isolinux.bin ]; then
  278. echo "Missing required isolinux files in $SYSLINUX_DATADIR, exiting..."
  279. exit 1
  280. fi
  281. # Check for root permissions.
  282. if [ "$(id -u)" -ne 0 ]; then
  283. echo "Must be run as root, exiting..."
  284. exit 1
  285. fi
  286. ISO_VOLUME="VOID_LIVE"
  287. if [ -n "$ROOTDIR" ]; then
  288. BUILDDIR=$(mktemp --tmpdir="$ROOTDIR" -d)
  289. else
  290. BUILDDIR=$(mktemp --tmpdir="$(pwd -P)" -d)
  291. fi
  292. BUILDDIR=$(readlink -f $BUILDDIR)
  293. ROOTFS="$BUILDDIR/rootfs"
  294. BOOT_DIR="$BUILDDIR/boot"
  295. ISOLINUX_DIR="$BOOT_DIR/isolinux"
  296. GRUB_DIR="$BOOT_DIR/grub"
  297. ISOLINUX_CFG="$ISOLINUX_DIR/isolinux.cfg"
  298. mkdir -p $ISOLINUX_DIR $GRUB_DIR
  299. #
  300. # Check there are repos registered before anything.
  301. #
  302. ${XBPS_QUERY_CMD} -L >/dev/null 2>&1
  303. if [ $? -ne 0 ]; then
  304. echo "No repositories available, exiting..."
  305. error_out
  306. fi
  307. XBPS_ARGS="-r $ROOTFS -y"
  308. XBPS_ARGS="$XBPS_ARGS -c $REPOSITORY_CACHE"
  309. XBPS_VERSION=$($XBPS_QUERY_CMD -V|awk '{print $2}')
  310. case $XBPS_VERSION in
  311. # XBPS >= 0.21
  312. [0-9].[2-9][1-9]*) ;;
  313. *) echo "Your xbps utilities are too old ($XBPS_VERSION), 0.21 is required."; exit 1;;
  314. esac
  315. # Sync index for remote repos first.
  316. $XBPS_INSTALL_CMD -r $ROOTFS -S >/dev/null 2>&1
  317. _linux_series=$($XBPS_QUERY_CMD -r $ROOTFS -Rx linux)
  318. KERNELVERSION=$($XBPS_QUERY_CMD -r $ROOTFS -R --property pkgver ${_linux_series})
  319. KERNELVERSION=$($XBPS_UHELPER_CMD getpkgversion $KERNELVERSION)
  320. if [ -z "$OUTPUT_FILE" ]; then
  321. OUTPUT_FILE="$HOME/void-live-$(uname -m)-${KERNELVERSION}-$(date +%Y%m%d).iso"
  322. fi
  323. info_msg "Redirecting stdout/stderr to $LOGFILE ..."
  324. #
  325. # Install live system and specified packages.
  326. #
  327. info_msg "[1/7] Installing packages into the rootfs..."
  328. install_packages
  329. #
  330. # Prepare /etc/motd.
  331. #
  332. mkdir -p "$ROOTFS"/etc
  333. write_etc_motd
  334. #
  335. # Generate the initramfs.
  336. #
  337. info_msg "[2/7] Generating initramfs image ($COMPRESSTYPE)..."
  338. generate_initramfs
  339. #
  340. # Generate the isolinux boot.
  341. #
  342. info_msg "[3/7] Generating isolinux support for PC-BIOS systems..."
  343. generate_isolinux_boot
  344. #
  345. # Generate the GRUB EFI boot.
  346. #
  347. info_msg "[4/7] Generating GRUB support for EFI systems..."
  348. generate_grub_efi_boot
  349. #
  350. # Generate the squashfs image from rootfs.
  351. #
  352. info_msg "[5/7] Generating squashfs image ($COMPRESSTYPE) from rootfs..."
  353. generate_squashfs
  354. #
  355. # Generate the ISO image.
  356. #
  357. info_msg "[6/7] Generating ISO image..."
  358. generate_iso_image
  359. info_msg "[7/7] Removing build directory..."
  360. rm -rf "$BUILDDIR"
  361. hsize=$(du -sh "$OUTPUT_FILE"|awk '{print $1}')
  362. info_msg "Created $(readlink -f $OUTPUT_FILE) ($hsize) successfully."
  363. exit 0